#include "can_network.h"
#include <QCanBus>
#include <QCanBusFrame>
#include <QCoreApplication>

CAN_Network::CAN_Network(QObject *parent) : QObject(parent)
{
    this->connectDevice();
}

CAN_Network::~CAN_Network(){
    delete m_canDevice;
    delete m_canDevice2;
}


void CAN_Network::start(QObject *qml){

    qmlObject = qml;

    connect(&timer, SIGNAL(timeout()), this, SLOT(doWork()));
    timer.start(1000);
}

void CAN_Network::connectDevice(){

    QString errorString;

    QString backendName = "vectorcan";
    QString deviceInterfaceName = "can2";

    m_canDevice = QCanBus::instance()->createDevice(backendName, deviceInterfaceName,
                                                    &errorString);

    if (!m_canDevice) {
        qDebug() << "Error creating device";

        return;
    }

    QVariant bitRate = m_canDevice->configurationParameter(QCanBusDevice::BitRateKey);

    qDebug() << bitRate.toString();


   if (m_canDevice->connectDevice())
       qDebug() << "DEV1 Connected";
   else
        qDebug() << "DEV1 NOT Connected";

   m_canDevice2 = QCanBus::instance()->createDevice(backendName,  "can4",
                                                   &errorString);
   if (!m_canDevice2) {
       qDebug() << "Error creating device";

       return;
   }

   if (m_canDevice2->connectDevice())
       qDebug() << "DEV2 Connected";
   else
        qDebug() << "DEV2 NOT Connected";
}

void CAN_Network::doWork(){
    QCoreApplication::processEvents();

    //m_canDevice2->waitForFramesReceived(-1);
    while (m_canDevice2->framesAvailable()) {

        const QCanBusFrame frame2 = m_canDevice2->readFrame();
        int canMessageId2;
        canMessageId2 = frame2.frameId();
        qDebug() << "CAN DEVICE 2";
        qDebug() << canMessageId2;
    }

    qDebug() << "CAN Device 2 loop finishes";

    QCoreApplication::processEvents();

    //m_canDevice->waitForFramesReceived(-1);

    while (m_canDevice->framesAvailable()) {
        const QCanBusFrame frame = m_canDevice->readFrame();

        int canMessageId;
        canMessageId = frame.frameId();
        qDebug() << "CAN DEVICE 1";
        qDebug() << canMessageId;
    }

}
